#define __CS 10
#define __DC 9


#include <EdWgfx.h>


// Color definitions
#define  BLACK   0
#define BLUE    2
#define GREEN   4
#define CYAN    9
#define MAGENTA 10
#define RED     11
#define WHITE   14
#define YELLOW  15


EdWgfx tft = EdWgfx(__CS, __DC);


void setup() {
  Serial.begin(38400);
  long unsigned debug_start = millis ();
  while (!Serial && ((millis () - debug_start) <= 5000)) ;
  tft.begin();
}


void loop(void) {
  /*
    uint8_t rd[38];
    tft.readId( rd );
    word adrDma;
    byte rd0, rd1, rd2, rd3, pusty;
    byte id[6], ver[4], typ[2];
    word cfg, dispX, dispY;
    word sx, sy, ex, ey;
    word cursX, cursY, colorPen, colorBack;
    byte io, pwmIn;

    uint8_t p = 0;
    adrDma = rd[p++];
    adrDma |= rd[p++] << 8;

    id[0] = rd[p++];
    id[1] = rd[p++];
    id[2] = rd[p++];
    id[3] = rd[p++];
    id[4] = rd[p++];
    id[5] = rd[p++];

    ver[0] = rd[p++];
    ver[1] = rd[p++];
    ver[2] = rd[p++];
    ver[3] = rd[p++];

    typ[1] = rd[p++];
    typ[0] = rd[p++];

    cfg = rd[p++] << 8;
    cfg |= rd[p++];
    dispX = rd[p++] << 8;
    dispX |= rd[p++];

    dispY = rd[p++] << 8;
    dispY |= rd[p++];
    sx = rd[p++];
    sx |= rd[p++];

    sy = rd[p++] << 8;
    sy |= rd[p++];
    ex = rd[p++] << 8;
    ex |= rd[p++];

    ey = rd[p++] << 8;
    ey |= rd[p++];
    cursX = rd[p++] << 8;
    cursX |= rd[p++];

    cursY = rd[p++] << 8;
    cursY |= rd[p++];
    colorPen = rd[p++] << 8;
    colorPen |= rd[p++];

    colorBack = rd[p++] << 8;
    colorBack |= rd[p++];
    pwmIn = rd[p++];
    io = rd[p++];

    char txt[100];
    Serial.println("Read:");
    for (uint8_t x = 0; x < 40; x++) {
    sprintf( txt, "%02x ", rd[x] ); if ( x % 16 || !x ) Serial.print(txt); else Serial.println(txt);
    }

    if ( ! id[3] ) id[3] = ' ';
    sprintf( txt, "\n\r\n\rID='%c%c%c%c' Ver='%c%c%c' Typ=%x%02x", id[0], id[1], id[2], id[3], ver[0], ver[1], ver[2], typ[1], typ[0] ); Serial.println(txt);
    sprintf( txt, "CFG=%x Szer=%d Wys=%d", cfg, dispX, dispY ); Serial.println(txt);
    sprintf( txt, "Okno=%x,%d do %d,%d Cursor=%d,%d, kolory=%d,%d", sx, sy, ex, ey, cursX, cursY, colorPen, colorBack ); Serial.print(txt);
    sprintf( txt, " PWM=%d IO=%x \n\r", pwmIn, io ); Serial.println(txt);
  */

  testText();
  delay(1000);
}



void testText() {
  byte static krok, c1, c2, c3, c4;
  switch ( krok & 3 ) {
    case 0: c1 = BLUE; c2 = YELLOW; c3 = RED; c4 = GREEN; break;
    case 1: c2 = BLUE; c3 = YELLOW; c4 = RED; c1 = GREEN; break;
    case 2: c3 = BLUE; c4 = YELLOW; c1 = RED; c2 = GREEN; break;
    default: c4 = BLUE; c1 = YELLOW; c2 = RED; c3 = GREEN; break;
  }
  krok++;
  krok &= 3;


  //--------------------------------------
  tft.setContinue( 1 ); // Rozkaz za rozkazem
  tft.fillScreen(0);


  for (byte x = 0; x < 128; x++) {
    tft.drawPixel( x, x, krok & 15 );
  }

  
  tft.setTextAtrybut( TFT_MODE_PROP );
  tft.setCursor(krok * 8, 0);
  tft.setTextColor(c1);
  tft.setTextSize(1);
  tft.printString("Hej"); // 4 bajty, 0 dope?nienia

  tft.setTextColor(c2);
  tft.setCursor(krok * 8, 16);
  tft.setTextAtrybut( 0 );
  tft.printString("Hej!"); // 5 bajtów, 3 dope?nienia

  tft.setTextColor(c3);
  tft.setCursor(krok * 8, 32);
  tft.setTextAtrybut( 0 );
  tft.printString("Hej !"); // 6 bajtów, 2 dope?nienia

  tft.setTextColor(c4);
  tft.setCursor(krok * 8, 48);
  tft.setTextAtrybut( 0 );
  tft.printString("Hej !!"); // 7 bajtów, 1 dope?nienia


  tft.display(); delay(35);
}





